# 033. Search in Rotated Sorted Array

**<font color=red>难度Medium<font>**

## 刷题内容
> 原题连接

* https://leetcode.com/problems/search-in-rotated-sorted-array/

> 内容描述

```
Suppose an array sorted in ascending order is rotated at some pivot unknown to you beforehand.

(i.e., [0,1,2,4,5,6,7] might become [4,5,6,7,0,1,2]).

You are given a target value to search. If found in the array return its index, otherwise return -1.

You may assume no duplicate exists in the array.

Your algorithm's runtime complexity must be in the order of O(log n).

Example 1:

Input: nums = [4,5,6,7,0,1,2], target = 0
Output: 4
Example 2:

Input: nums = [4,5,6,7,0,1,2], target = 3
Output: -1
```
> 思路1
******- 时间复杂度: O(n)******- 空间复杂度: O(1)******

第一个方法是直接遍历数组，找到返回数组下标，找不到就返回-1

```cpp
class Solution {
public:
    int search(vector<int>& nums, int target) {
        for(int i = 0;i < nums.size();++i)
            if(nums[i] == target)
                return i;
        return -1;
    }
};
```
> 思路2
******- 时间复杂度: O(lgn)*****- 空间复杂度: O(1)******

第二个方法是用二分法找到旋转轴，再用二分法找到目标数
```cpp
class Solution {
public:
    int search(vector<int>& nums, int target) {
       int i = 0,j = nums.size() - 1;
    if(!nums.size())
        return -1;
    while(i < j - 1)
    {
        int mid = (i + j) / 2;
        if(nums[i] < nums[mid])
            i = mid;
        else
            j = mid;
    //cout << i << j << endl;
    }
    if(nums[i] <= nums[j])
        j = i;
    //cout << j;
    auto pos = lower_bound(nums.begin(),nums.begin() + j,target);
    if(pos != nums.end() && (*pos) == target)
        return pos - nums.begin();
    pos = lower_bound(nums.begin() + j,nums.end(),target);
    if(pos != nums.end() && (*pos) == target)
        return pos - nums.begin();
    return -1;
    }
};
```
