# 9. Palindrome Number

**<font color=red>难度: Easy</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/palindrome-number/

> 内容描述

```
Determine whether an integer is a palindrome. An integer is a palindrome when it reads the same backward as forward.

Example 1:

Input: 121
Output: true
Example 2:

Input: -121
Output: false
Explanation: From left to right, it reads -121. From right to left, it becomes 121-. Therefore it is not a palindrome.
Example 3:

Input: 10
Output: false
Explanation: Reads 01 from right to left. Therefore it is not a palindrome.
Follow up:

Coud you solve it without converting the integer to a string?
```

## 解题方案

> 思路 1
******- 时间复杂度: O(1)******- 空间复杂度: O(1)******

> 思路1 （满足Follow up)

- 首先负数肯定不是palindrome
- 其次如果一个数字是一个正数，并且能被我10整除那它肯定也不是palindrome，因为首位肯定不是 0

这样降低了复杂度

```python
class Solution(object):
    def isPalindrome(self, x):
        """
        :type x: int
        :rtype: bool
        """
        if x < 0 or (x != 0 and x % 10 == 0):
            return False
        rev, y = 0, x
        while x > 0:
            rev = rev * 10 + x % 10
            x /= 10
        return y == rev
        
```

> 思路 2
******- 时间复杂度: O(1)******- 空间复杂度: O(1)******

* 排除小于0的数
* 通过字符串进行反转，对比数字是否相等就行

```python
class Solution:
    def isPalindrome(self, x):
        """
        :type x: int
        :rtype: bool
        """
        if x < 0:
            return False
        elif x != int(str(x)[::-1]):
            return False
        else:
            return True
```
