# 26. Remove Duplicates from Sorted Array

**<font color=red>难度: Easy</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/remove-duplicates-from-sorted-array/description/

> 内容描述

```
Given a sorted array nums, remove the duplicates in-place such that each element appear only once and return the new length.

Do not allocate extra space for another array, you must do this by modifying the input array in-place with O(1) extra memory.

Example 1:

Given nums = [1,1,2],

Your function should return length = 2, with the first two elements of nums being 1 and 2 respectively.

It doesn't matter what you leave beyond the returned length.
Example 2:

Given nums = [0,0,1,1,1,2,2,3,3,4],

Your function should return length = 5, with the first five elements of nums being modified to 0, 1, 2, 3, and 4 respectively.

It doesn't matter what values are set beyond the returned length.
Clarification:

Confused why the returned value is an integer but your answer is an array?

Note that the input array is passed in by reference, which means modification to the input array will be known to the caller as well.

Internally you can think of this:

// nums is passed in by reference. (i.e., without making a copy)
int len = removeDuplicates(nums);

// any modification to nums in your function would be known by the caller.
// using the length returned by your function, it prints the first len elements.
for (int i = 0; i < len; i++) {
    print(nums[i]);
}
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N^2)******- 空间复杂度: O(1)******

因为题目说了是```sorted array```，所以只需要不停判断当前位置值和下一位置是否相等，若相等则```pop掉当前值```，否则```move```到下一位置做重复判断

beats 39.49%

```python
class Solution(object):
    def removeDuplicates(self, nums):
        """
        :type nums: List[int]
        :rtype: int
        """
        idx = 0
        while idx < len(nums) - 1:
            if nums[idx] == nums[idx+1]:
                nums.pop(idx)
            else:
                idx += 1
        return len(nums)
```


这里代码用```while loop```而不用```for loop```是因为```pop```操作之后```nums```的长度会变化

如：```for i in range(len(nums)-1)```实际上固定了```range```里面的值了，不会二次判断

```
n = 10
for i in range(n):
    n = n - 1  # 尽管n在变化
    print(i)

上面这段代码的输出结果为：

0
1
2
3
4
5
6
7
8
9
```

> 思路 2
******- 时间复杂度: O(N)******- 空间复杂度: O(1)******


思路直接看代码就能明白或者去看[leetcode 第80题](https://github.com/apachecn/awesome-algorithm/blob/master/docs/Leetcode_Solutions/Python/080._remove_duplicates_from_sorted_array_ii.md)

beats 99.62%

```python
class Solution(object):
    def removeDuplicates(self, nums):
        """
        :type nums: List[int]
        :rtype: int
        """
        idx = 0
        for num in nums:
            if idx < 1 or num != nums[idx-1]:
                nums[idx] = num
                idx += 1
        return idx
```
















