# 63. Unique Paths II

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/unique-paths-ii/

> 内容描述

```
A robot is located at the top-left corner of a m x n grid (marked 'Start' in the diagram below).

The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked 'Finish' in the diagram below).

Now consider if some obstacles are added to the grids. How many unique paths would there be?



An obstacle and empty space is marked as 1 and 0 respectively in the grid.

Note: m and n will be at most 100.

Example 1:

Input:
[
  [0,0,0],
  [0,1,0],
  [0,0,0]
]
Output: 2
Explanation:
There is one obstacle in the middle of the 3x3 grid above.
There are two ways to reach the bottom-right corner:
1. Right -> Right -> Down -> Down
2. Down -> Down -> Right -> Right
```

## 解题方案

> 思路 1
******- 时间复杂度: O(M * N)******- 空间复杂度: O(1)******

递归+DFS

有个很恶心的case，就是obstacleGrid[0][0] == 1，这样怎么都走不到右下角

但是超时了

```
class Solution(object):
    def uniquePathsWithObstacles(self, obstacleGrid):
        """
        :type obstacleGrid: List[List[int]]
        :rtype: int
        """
        self.res = 0
        def travel(x, y):
            if x == len(obstacleGrid) - 1 and y == len(obstacleGrid[0]) - 1 and obstacleGrid[x][y] != 1:
                self.res += 1
            if x + 1 <= len(obstacleGrid) - 1 and obstacleGrid[x+1][y] != 1:
                travel(x+1, y)
            if y + 1 <= len(obstacleGrid[0]) - 1 and obstacleGrid[x][y+1] != 1:
                travel(x, y+1)
                
        if obstacleGrid[0][0] == 1:
            return 0
        travel(0, 0)
        return self.res
```


> 思路 2
******- 时间复杂度: O(M * N)******- 空间复杂度: O(M * N)******

加一个cache

beats 66.49%

```python
class Solution(object):
    def uniquePathsWithObstacles(self, obstacleGrid):
        """
        :type obstacleGrid: List[List[int]]
        :rtype: int
        """  
        cache = {}
        def travel(x, y):
            if (x, y) in cache:
                return cache[x, y]
            res = 0
            if obstacleGrid[x][y] == 0:
                if x + 1 <= len(obstacleGrid) - 1:
                    res += travel(x+1, y)
                if y + 1<= len(obstacleGrid[0]) - 1:
                    res += travel(x, y+1)
                if x == len(obstacleGrid) - 1 and y == len(obstacleGrid[0]) - 1:
                    res += 1
            cache[x, y] = res
            return cache[x, y]
                
        if obstacleGrid[0][0] == 1:
            return 0
        return travel(0, 0)
```


> 思路 3
******- 时间复杂度: O(M * N)******- 空间复杂度: O(M * N)******

DP， beats 100%

```python
class Solution(object):
    def uniquePathsWithObstacles(self, obstacleGrid):
        """
        :type obstacleGrid: List[List[int]]
        :rtype: int
        """
        m = len(obstacleGrid)
        n = len(obstacleGrid[0])

        # If the starting cell has an obstacle, then simply return as there would be
        # no paths to the destination.
        if obstacleGrid[0][0] == 1:
            return 0

        # Number of ways of reaching the starting cell = 1.
        obstacleGrid[0][0] = 1

        # Filling the values for the first column
        for i in range(1, m):
            obstacleGrid[i][0] = int(obstacleGrid[i][0] == 0 and obstacleGrid[i-1][0] == 1)

        # Filling the values for the first row        
        for j in range(1, n):
            obstacleGrid[0][j] = int(obstacleGrid[0][j] == 0 and obstacleGrid[0][j-1] == 1)

        # Starting from cell(1,1) fill up the values
        # No. of ways of reaching cell[i][j] = cell[i - 1][j] + cell[i][j - 1]
        # i.e. From above and left.
        for i in range(1, m):
            for j in range(1, n):
                if obstacleGrid[i][j] == 0:
                    obstacleGrid[i][j] = obstacleGrid[i-1][j] + obstacleGrid[i][j-1]
                else:
                    obstacleGrid[i][j] = 0

        # Return value stored in rightmost bottommost cell. That is the destination.            
        return obstacleGrid[m-1][n-1]
```
























