# 147. Insertion Sort List

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/insertion-sort-list/

> 内容描述

```
Sort a linked list using insertion sort.


A graphical example of insertion sort. The partial sorted list (black) initially contains only the first element in the list.
With each iteration one element (red) is removed from the input data and inserted in-place into the sorted list
 

Algorithm of Insertion Sort:

Insertion sort iterates, consuming one input element each repetition, and growing a sorted output list.
At each iteration, insertion sort removes one element from the input data, finds the location it belongs within the sorted list, and inserts it there.
It repeats until no input elements remain.

Example 1:

Input: 4->2->1->3
Output: 1->2->3->4
Example 2:

Input: -1->5->3->4->0
Output: -1->0->3->4->5
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N^2)******- 空间复杂度: O(1)******

dummy head, beats 23.68%

```python
class Solution:
    def insertionSortList(self, head):
        """
        :type head: ListNode
        :rtype: ListNode
        """
        if not head:
            return head
        dummy = ListNode(None) # new starter of the sorted list
        cur, pre, nxt = head, dummy, None
        while cur:
            nxt = cur.next
            # find the right place to insert
            while pre.next and pre.next.val < cur.val:
                pre = pre.next
            # insert between pre and pre.next
            cur.next = pre.next 
            pre.next = cur
            pre = dummy
            cur = nxt
        return dummy.next
```



































