# 154. Find Minimum in Rotated Sorted Array II

**<font color=red>难度: Hard</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/find-minimum-in-rotated-sorted-array-ii/description/

> 内容描述

```
Suppose an array sorted in ascending order is rotated at some pivot unknown to you beforehand.

(i.e.,  [0,1,2,4,5,6,7] might become  [4,5,6,7,0,1,2]).

Find the minimum element.

The array may contain duplicates.

Example 1:

Input: [1,3,5]
Output: 1
Example 2:

Input: [2,2,2,0,1]
Output: 0
Note:

This is a follow up problem to Find Minimum in Rotated Sorted Array.
Would allow duplicates affect the run-time complexity? How and why?
```

## 解题方案

> 思路 1
******- 时间复杂度: O(NlgN)******- 空间复杂度: O(1)******

python大法好，一行sb AC, beats 100%，可能测试用例大多数都是基本有序的吧

```python
class Solution(object):
    def findMin(self, nums):
        """
        :type nums: List[int]
        :rtype: int
        """
        nums.sort()
        return nums[0]
```

> 思路 2
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******


跟第153题没啥区别，就先把重复元素去掉就行了

2分钟 AC, beats 67.63%


```python
class Solution(object):
    def findMin(self, nums):
        """
        :type nums: List[int]
        :rtype: int
        """
        lookup, new_nums = {}, []
        for num in nums:
            if num not in lookup:
                lookup[num] = 1
                new_nums.append(num)
        if len(new_nums) == 1:
            return new_nums[0]
        pivot = new_nums[0]
        for i in range(1, len(new_nums)):
            if new_nums[i] < pivot:
                return new_nums[i]
            pivot = new_nums[i]
        return new_nums[0]
```

> 思路 3
******- 时间复杂度: O(lgN)******- 空间复杂度: O(1)******


二分法，思路看代码一目了然，[leetcode第33题](https://github.com/apachecn/awesome-algorithm/blob/master/docs/Leetcode_Solutions/Python/033._search_in_rotated_sorted_array.md)这道题很类似，我画了图的，可以看看

beats 100%

```python
class Solution(object):
    def findMin(self, nums):
        """
        :type nums: List[int]
        :rtype: int
        """
        l, r = 0, len(nums) - 1
        while l <= r:
            mid = l + ((r-l) >> 1)
            if nums[mid] < nums[mid-1]:
                return nums[mid]
            elif nums[mid] < nums[l]:
                r = mid - 1
            elif nums[mid] > nums[r]:
                l = mid + 1
            elif l != r and nums[l] == nums[r]:
                l += 1
            else:
                return nums[l]
```


## Note

```
Would allow duplicates affect the run-time complexity? How and why?
```

回答：Duplicates will not affect run-time complexity, because we can also use binary search to handle duplicates, same time complexity
























