# 213. House Robber II

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/house-robber-ii

> 内容描述

```
You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed. All houses at this place are arranged in a circle. That means the first house is the neighbor of the last one. Meanwhile, adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

Example 1:

Input: [2,3,2]
Output: 3
Explanation: You cannot rob house 1 (money = 2) and then rob house 3 (money = 2),
             because they are adjacent houses.
Example 2:

Input: [1,2,3,1]
Output: 4
Explanation: Rob house 1 (money = 1) and then rob house 3 (money = 3).
             Total amount you can rob = 1 + 3 = 4.
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******

就是rober I的基础上变一下, 取rob(nums[1:], nums[:-1])中的较大值

beats 97.45%

```python
class Solution:
    def rob(self, nums):
        """
        :type nums: List[int]
        :rtype: int
        """
        n = len(nums)
        if n == 0:
            return 0
        elif n == 1:
            return nums[0]
        elif n == 2:
            return max(nums[0], nums[1])
        else:
            def helper(nums):
                n = len(nums)
                if n == 0:
                    return 0
                elif n == 1:
                    return nums[0]
                elif n == 2:
                    return max(nums[0], nums[1])
                dp = [0 for i in range(n)]
                dp[0] = nums[0]
                dp[1] = max(nums[0],nums[1])
                for i in range(2, n):
                    dp[i] = max(dp[i-1], dp[i-2] + nums[i])
                return dp[-1]
            return max(helper(nums[:-1]), helper(nums[1:]))
```



> 思路 2
******- 时间复杂度: O(N)******- 空间复杂度: O(1)******

就是rober I的基础上变一下, 取rob(nums[1:], nums[:-1])中的较大值

迭代

beats 97.45%



```python
class Solution:
    def rob(self, nums):
        """
        :type nums: List[int]
        :rtype: int
        """
        n = len(nums)
        if n == 0:
            return 0
        elif n == 1:
            return nums[0]
        elif n == 2:
            return max(nums[0], nums[1])
        else:
            def helper(nums):
                last, now = 0, 0
                for num in nums:
                    last, now = now, max(last+num, now)
                return now
            return max(helper(nums[:-1]), helper(nums[1:]))
```
























