# 238. Product of Array Except Self

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/two-sum

> 内容描述

```
Given an array nums of n integers where n > 1,  return an array output such that output[i] is equal to the product of all the elements of nums except nums[i].

Example:

Input:  [1,2,3,4]
Output: [24,12,8,6]
Note: Please solve it without division and in O(n).

Follow up:
Could you solve it with constant space complexity? (The output array does not count as extra space for the purpose of space complexity analysis.)
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******

前缀积和后缀积

beats 74.92%

```python
class Solution(object):
    def productExceptSelf(self, nums):
        """
        :type nums: List[int]
        :rtype: List[int]
        """
        pref_prod = [nums[0]] * len(nums)
        suff_prod = [nums[-1]] * len(nums)
        for i in range(1, len(nums)):
            pref_prod[i] = pref_prod[i-1] * nums[i]
        for i in range(len(nums)-2, -1, -1):
            suff_prod[i] = suff_prod[i+1] * nums[i]
        res = [0] * len(nums)
        res[0] = suff_prod[1]
        res[-1] = pref_prod[-2]
        for i in range(1, len(nums)-1):
            res[i] = pref_prod[i-1] * suff_prod[i+1]
        return res
```

# Follow up:
Could you solve it with constant space complexity? (The output array does not count as extra space for the purpose of space complexity analysis.)

> 思路 1
******- 时间复杂度: O(N)******- 空间复杂度: O(1)******

还是一样的思想，只不过不记录下来，而是采用边循环边更新的方式

beats 99.49%


```python
class Solution(object):
    def productExceptSelf(self, nums):
        """
        :type nums: List[int]
        :rtype: List[int]
        """
        res = [1] * len(nums)
        
        left = 1
        for i in range(len(nums)-1):
            left *= nums[i]
            res[i+1] *= left
            
        right = 1
        for i in range(len(nums)-1, 0, -1):
            right *= nums[i]
            res[i-1] *= right
            
        return res
```
