# 299. Bulls and Cows

**<font color=orange>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/bulls-and-cows/

> 内容描述

```
You are playing the following Bulls and Cows game with your friend: You write down a number and ask your friend to guess what the number is. Each time your friend makes a guess, you provide a hint that indicates how many digits in said guess match your secret number exactly in both digit and position (called "bulls") and how many digits match the secret number but locate in the wrong position (called "cows"). Your friend will use successive guesses and hints to eventually derive the secret number.

Write a function to return a hint according to the secret number and friend's guess, use A to indicate the bulls and B to indicate the cows. 

Please note that both secret number and friend's guess may contain duplicate digits.

Example 1:

Input: secret = "1807", guess = "7810"

Output: "1A3B"

Explanation: 1 bull and 3 cows. The bull is 8, the cows are 0, 1 and 7.
Example 2:

Input: secret = "1123", guess = "0111"

Output: "1A1B"

Explanation: The 1st 1 in friend's guess is a bull, the 2nd or 3rd 1 is a cow.
Note: You may assume that the secret number and your friend's guess only contain digits, and their lengths are always equal.
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******


- bulls = secret与guess下标与数值均相同的数字个数
- cows = secret与guess中出现数字的公共部分 - bulls

```python
class Solution:
    def getHint(self, secret: str, guess: str) -> str:
        cnt = collections.defaultdict(int)
        bulls, cows = set(), set()
        for i in range(len(secret)):
            if guess[i] == secret[i]:
                bulls.add(i)
            else:
                cnt[secret[i]] += 1
        for i in range(len(guess)):
            if i not in bulls:
                if cnt[guess[i]] > 0:
                    cows.add(i)
                    cnt[guess[i]] -= 1
        return str(len(bulls)) + 'A' + str(len(cows)) + 'B'
```

> 思路 2
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******

其实可以写的更简单一些

```python
class Solution:
    def getHint(self, secret: str, guess: str) -> str:
        bulls = sum(map(operator.eq, secret, guess))
        cnts = collections.Counter(secret)
        cntg = collections.Counter(guess)
        cows = sum((cnts & cntg).values()) - bulls # # & operator means intersection:  min(c[x], d[x])
        return str(bulls) + 'A' + str(cows) + 'B'
```

来分析一下这个解法

```
def getHint(self, secret, guess):
    bulls = sum(map(operator.eq, secret, guess))
    both = sum(min(secret.count(x), guess.count(x)) for x in '0123456789')
    return '%dA%dB' % (bulls, both - bulls)
```

首先map的用法是,对于iterable中的每个元素应用function方法，将结果作为list返回

```
>>> def add100(x):
...     return x+100
... 
>>> hh = [11,22,33]
>>> map(add100,hh)
[111, 122, 133]
```

用'1123','0111' 来测试：

```
map(operator.eq, secret, guess)
[False, True, False, False]
```

就是将equal函数并行应用在两个string上，然后后面的解法也是粗暴简约和厉害
