# 381. Insert Delete GetRandom O(1) - Duplicates allowed

**<font color=red>难度: Hard</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/insert-delete-getrandom-o1-duplicates-allowed/description/

> 内容描述

```
Design a data structure that supports all following operations in average O(1) time.

Note: Duplicate elements are allowed.
insert(val): Inserts an item val to the collection.
remove(val): Removes an item val from the collection if present.
getRandom: Returns a random element from current collection of elements. The probability of each element being returned is linearly related to the number of same value the collection contains.
Example:

// Init an empty collection.
RandomizedCollection collection = new RandomizedCollection();

// Inserts 1 to the collection. Returns true as the collection did not contain 1.
collection.insert(1);

// Inserts another 1 to the collection. Returns false as the collection contained 1. Collection now contains [1,1].
collection.insert(1);

// Inserts 2 to the collection, returns true. Collection now contains [1,1,2].
collection.insert(2);

// getRandom should return 1 with the probability 2/3, and returns 2 with the probability 1/3.
collection.getRandom();

// Removes 1 from the collection, returns true. Collection now contains [1,2].
collection.remove(1);

// getRandom should return 1 and 2 both equally likely.
collection.getRandom();
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******




要注意len(self.lst)是O(1)的

beats 96.28%



```python
class RandomizedCollection(object):

    def __init__(self):
        """
        Initialize your data structure here.
        """
        self.cache = collections.defaultdict(set)
        self.lst = []
        

    def insert(self, val):
        """
        Inserts a value to the collection. Returns true if the collection did not already contain the specified element.
        :type val: int
        :rtype: bool
        """
        self.lst.append(val)
        self.cache[val].add(len(self.lst)-1)
        return len(self.cache[val]) == 1
        

    def remove(self, val):
        """
        Removes a value from the collection. Returns true if the collection contained the specified element.
        :type val: int
        :rtype: bool
        """
        if self.cache[val]:
            idx = self.cache[val].pop()
            self.lst[idx] = self.lst[-1]
            # order of two lines below can not be changed
            # we have to consider there is a condition, self.lst only have one val
            # and val is at the end of our self.lst
            self.cache[self.lst[-1]].add(idx)
            self.cache[self.lst[-1]].discard(len(self.lst) - 1)
            self.lst.pop()
            return True
        return False 
        

    def getRandom(self):
        """
        Get a random element from the collection.
        :rtype: int
        """
        return random.choice(self.lst)
        


# Your RandomizedCollection object will be instantiated and called as such:
# obj = RandomizedCollection()
# param_1 = obj.insert(val)
# param_2 = obj.remove(val)
# param_3 = obj.getRandom()
```
