# 475. Heaters

**<font color=red>难度: Easy</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/heaters/

> 内容描述

```
Winter is coming! Your first job during the contest is to design a standard heater with fixed warm radius to warm all the houses.

Now, you are given positions of houses and heaters on a horizontal line, find out minimum radius of heaters so that all houses could be covered by those heaters.

So, your input will be the positions of houses and heaters seperately, and your expected output will be the minimum radius standard of heaters.

Note:
Numbers of houses and heaters you are given are non-negative and will not exceed 25000.
Positions of houses and heaters you are given are non-negative and will not exceed 10^9.
As long as a house is in the heaters' warm radius range, it can be warmed.
All the heaters follow your radius standard and the warm radius will the same.
Example 1:
Input: [1,2,3],[2]
Output: 1
Explanation: The only heater was placed in the position 2, and if we use the radius 1 standard, then all the houses can be warmed.
Example 2:
Input: [1,2,3,4],[1,4]
Output: 1
Explanation: The two heater was placed in the position 1 and 4. We need to use radius 1 standard, then all the houses can be warmed.
```

## 解题方案

> 思路 1
******- 时间复杂度: O(max(mlgn, nlgn))******- 空间复杂度: O(1)******

基本思想是，我们将heaters排好序之后，我们找到每一个house在其中的位置（采用二分，提升效率）
- 然后如果某一个house左边和右边都有heater的话，我们就看看哪一个heater离他更近，并且求出那个距离
- 对于所有house都求出一个对应可以满足被cover到的radius之后，我们取得其中的最大值，这样就使得每一个house都被cover

假设`houses`的长度为`m`，`heaters`的长度为`n`，那么时间复杂度为`O(max(mlgn, nlgn)`

```python
class Solution:
    def findRadius(self, houses, heaters):
        """
        :type houses: List[int]
        :type heaters: List[int]
        :rtype: int
        """
        heaters.sort()
        res = -sys.maxsize
        for house in houses:
            idx = bisect.bisect_left(heaters, house)
            if idx < 0:
                continue
            dis1 = house - heaters[idx-1] if idx >= 1 else sys.maxsize
            dis2 = heaters[idx] - house if idx < len(heaters) else sys.maxsize
            res = max(res, min(dis1, dis2))
        return res
```































