# 499. The Maze III

**<font color=red>难度: Hard</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/the-maze-iii/

> 内容描述

```
There is a ball in a maze with empty spaces and walls. The ball can go through empty spaces by rolling up (u), down (d), left (l) or right (r), but it won't stop rolling until hitting a wall. When the ball stops, it could choose the next direction. There is also a hole in this maze. The ball will drop into the hole if it rolls on to the hole.

Given the ball position, the hole position and the maze, find out how the ball could drop into the hole by moving the shortest distance. The distance is defined by the number of empty spaces traveled by the ball from the start position (excluded) to the hole (included). Output the moving directions by using 'u', 'd', 'l' and 'r'. Since there could be several different shortest ways, you should output the lexicographically smallest way. If the ball cannot reach the hole, output "impossible".

The maze is represented by a binary 2D array. 1 means the wall and 0 means the empty space. You may assume that the borders of the maze are all walls. The ball and the hole coordinates are represented by row and column indexes.

 

Example 1:

Input 1: a maze represented by a 2D array

0 0 0 0 0
1 1 0 0 1
0 0 0 0 0
0 1 0 0 1
0 1 0 0 0

Input 2: ball coordinate (rowBall, colBall) = (4, 3)
Input 3: hole coordinate (rowHole, colHole) = (0, 1)

Output: "lul"

Explanation: There are two shortest ways for the ball to drop into the hole.
The first way is left -> up -> left, represented by "lul".
The second way is up -> left, represented by 'ul'.
Both ways have shortest distance 6, but the first way is lexicographically smaller because 'l' < 'u'. So the output is "lul".

Example 2:

Input 1: a maze represented by a 2D array

0 0 0 0 0
1 1 0 0 1
0 0 0 0 0
0 1 0 0 1
0 1 0 0 0

Input 2: ball coordinate (rowBall, colBall) = (4, 3)
Input 3: hole coordinate (rowHole, colHole) = (3, 0)

Output: "impossible"

Explanation: The ball cannot reach the hole.

 

Note:

There is only one ball and one hole in the maze.
Both the ball and hole exist on an empty space, and they will not be at the same position initially.
The given maze does not contain border (like the red rectangle in the example pictures), but you could assume the border of the maze are all walls.
The maze contains at least 2 empty spaces, and the width and the height of the maze won't exceed 30.
```

## 解题方案

> 思路 1
******- 时间复杂度: O(row * col)******- 空间复杂度: O(row * col)******


DFS + priority queue

```python
from heapq import *
class Solution:
    def findShortestWay(self, maze, ball, hole):
        """
        :type maze: List[List[int]]
        :type ball: List[int]
        :type hole: List[int]
        :rtype: str
        """
        row = len(maze)
        col = len(maze[0]) if row else 0
        stopped = {(ball[0], ball[1]): [0, '']}
        queue = [(0, '', ball[0], ball[1])]
        while queue:
            dis, path, x, y = heappop(queue)
            if [x, y] == hole:
                return path
            for i, j, p in [(-1, 0, 'u'), (1, 0, 'd'), (0, 1, 'r'), (0, -1, 'l')]:
                tmp_x, tmp_y = x, y
                tmp_dis = 0
                while 0 <= tmp_x + i < row and 0 <= tmp_y + j < col and maze[tmp_x+i][tmp_y+j] != 1:
                    tmp_x += i
                    tmp_y += j
                    tmp_dis += 1
                    if [tmp_x, tmp_y] == hole:
                        break
                if (tmp_x, tmp_y) not in stopped or [dis + tmp_dis, path + p] < stopped[(tmp_x, tmp_y)]:
                    stopped[(tmp_x, tmp_y)] = [dis + tmp_dis, path + p]
                    heappush(queue, (dis + tmp_dis, path + p, tmp_x, tmp_y))
        return 'impossible'
```































