# 505. The Maze II

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/the-maze-ii/

> 内容描述

```
There is a ball in a maze with empty spaces and walls. The ball can go through empty spaces by rolling up, down, left or right, but it won't stop rolling until hitting a wall. When the ball stops, it could choose the next direction.

Given the ball's start position, the destination and the maze, find the shortest distance for the ball to stop at the destination. The distance is defined by the number of empty spaces traveled by the ball from the start position (excluded) to the destination (included). If the ball cannot stop at the destination, return -1.

The maze is represented by a binary 2D array. 1 means the wall and 0 means the empty space. You may assume that the borders of the maze are all walls. The start and destination coordinates are represented by row and column indexes.

 

Example 1:

Input 1: a maze represented by a 2D array

0 0 1 0 0
0 0 0 0 0
0 0 0 1 0
1 1 0 1 1
0 0 0 0 0

Input 2: start coordinate (rowStart, colStart) = (0, 4)
Input 3: destination coordinate (rowDest, colDest) = (4, 4)

Output: 12

Explanation: One shortest way is : left -> down -> left -> down -> right -> down -> right.
             The total distance is 1 + 1 + 3 + 1 + 2 + 2 + 2 = 12.

Example 2:

Input 1: a maze represented by a 2D array

0 0 1 0 0
0 0 0 0 0
0 0 0 1 0
1 1 0 1 1
0 0 0 0 0

Input 2: start coordinate (rowStart, colStart) = (0, 4)
Input 3: destination coordinate (rowDest, colDest) = (3, 2)

Output: -1

Explanation: There is no way for the ball to stop at the destination.

 

Note:

There is only one ball and one destination in the maze.
Both the ball and the destination exist on an empty space, and they will not be at the same position initially.
The given maze does not contain border (like the red rectangle in the example pictures), but you could assume the border of the maze are all walls.
The maze contains at least 2 empty spaces, and both the width and height of the maze won't exceed 100.
```

## 解题方案

> 思路 1
******- 时间复杂度: O(row * col)******- 空间复杂度: O(row * col)******



DFS + priority queue

```python
from heapq import *
class Solution:
    def shortestDistance(self, maze, start, destination):
        """
        :type maze: List[List[int]]
        :type start: List[int]
        :type destination: List[int]
        :rtype: int
        """
        row = len(maze)
        col = len(maze[0]) if row else 0
        stopped = {(start[0], start[1]): 0}
        queue = [(0, start[0], start[1])]
        while queue:
            dis, x, y = heappop(queue)
            if [x, y] == destination:
                return dis
            for i, j in [(-1, 0), (1, 0), (0, 1), (0, -1)]:
                tmp_x, tmp_y = x, y
                tmp_dis = 0
                while 0 <= tmp_x + i < row and 0 <= tmp_y + j < col and maze[tmp_x+i][tmp_y+j] != 1:
                    tmp_x += i
                    tmp_y += j
                    tmp_dis += 1
                if (tmp_x, tmp_y) not in stopped or dis + tmp_dis < stopped[(tmp_x, tmp_y)]:
                    stopped[(tmp_x, tmp_y)] = dis + tmp_dis
                    heappush(queue, (dis + tmp_dis, tmp_x, tmp_y))
        return -1
```
































