# 724. Find Pivot Index

**<font color=red>难度: Easy</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/find-pivot-index/description/

> 内容描述

```
Given an array of integers nums, write a method that returns the "pivot" index of this array.

We define the pivot index as the index where the sum of the numbers to the left of the index is equal to the sum of the numbers to the right of the index.

If no such index exists, we should return -1. If there are multiple pivot indexes, you should return the left-most pivot index.

Example 1:
Input: 
nums = [1, 7, 3, 6, 5, 6]
Output: 3
Explanation: 
The sum of the numbers to the left of index 3 (nums[3] = 6) is equal to the sum of numbers to the right of index 3.
Also, 3 is the first index where this occurs.
Example 2:
Input: 
nums = [1, 2, 3]
Output: -1
Explanation: 
There is no index that satisfies the conditions in the problem statement.
Note:

The length of nums will be in the range [0, 10000].
Each element nums[i] will be an integer in the range [-1000, 1000].
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******



前缀和数组+后缀和数组，实现时间复杂度O(n)和空间复杂度O(n)，3分钟 bug free



```python
class Solution(object):
    def pivotIndex(self, nums):
        """
        :type nums: List[int]
        :rtype: int
        """
        if not nums or len(nums) == 0:
            return -1
            
        prefix_sums = [nums[0]] * len(nums)
        for i in range(1, len(nums)):
            prefix_sums[i] = nums[i] + prefix_sums[i-1]
            
        suffix_sums = [nums[-1]] * len(nums)
        for i in range(len(nums)-2, -1, -1):
            suffix_sums[i] = nums[i] + suffix_sums[i+1]
            
        sums = sum(nums)
        if sum(nums[1:]) == 0:
            return 0
        for i in range(1, len(nums)):
            if prefix_sums[i] == suffix_sums[i]:
                return i
        return -1
```

> 思路 2
******- 时间复杂度: O(N)******- 空间复杂度: O(1)******

后面发现其实空间只要O(1)就可以了，就是用left_sum, right_sum分别代表左右两边的和，初始化为0和sum(nums)

```python
class Solution(object):
    def pivotIndex(self, nums):
        """
        :type nums: List[int]
        :rtype: int
        """
        left_sum, right_sum = 0, sum(nums)
        for idx, num in enumerate(nums):
            right_sum -= num
            if left_sum == right_sum:
                return idx
            left_sum += num
        return -1
```


       
       
       
       
       
       
       
       
       
       
       
       
       
       
