# 729. My Calendar I

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/my-calendar-i/

> 内容描述

```
Implement a MyCalendar class to store your events. A new event can be added if adding the event will not cause a double booking.

Your class will have the method, book(int start, int end). Formally, this represents a booking on the half open interval [start, end), the range of real numbers x such that start <= x < end.

A double booking happens when two events have some non-empty intersection (ie., there is some time that is common to both events.)

For each call to the method MyCalendar.book, return true if the event can be added to the calendar successfully without causing a double booking. Otherwise, return false and do not add the event to the calendar.

Your class will be called like this: MyCalendar cal = new MyCalendar(); MyCalendar.book(start, end)
Example 1:
MyCalendar();
MyCalendar.book(10, 20); // returns true
MyCalendar.book(15, 25); // returns false
MyCalendar.book(20, 30); // returns true
Explanation: 
The first event can be booked.  The second can't because time 15 is already booked by another event.
The third event can be booked, as the first event takes every time less than 20, but not including 20.
Note:

The number of calls to MyCalendar.book per test case will be at most 1000.
In calls to MyCalendar.book(start, end), start and end are integers in the range [0, 10^9].
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N^2)******- 空间复杂度: O(N)******





按照start的顺序排列插入events，然后挨个比对，如果重叠了就return False，如果没有就把当前events插入到正确的排列顺序后，return True即可

beats 24.71%


```python
class MyCalendar(object):

    def __init__(self):
        self.events = []

    def book(self, start, end):
        """
        :type start: int
        :type end: int
        :rtype: bool
        """
        for i in range(len(self.events)):
            time = self.events[i]
            if start < time[1] and end > time[0]:
                return False
            # if start >= time[1]:
            if start < time[0]:
                self.events.insert(i, (start, end))
                return True
        self.events.append((start, end))
        return True
```


> 思路 2
******- 时间复杂度: O(lgN)******- 空间复杂度: O(N)******



刚才我们是挨个比对，所以比对过程是O(N)，但是由于我们已经保证了start按照升序排列，所以我们可以用二分算出合理的插入位置，然后看看是否有冲突即可

二分的实现可以用BST来实现，自己实现一下BST吧

beats 47.40%

```python
class Node:
    def __init__(self, start, end):
        self.start = start
        self.end = end
        self.left = self.right = None

    def insert(self, node):
        if node.start >= self.end:
            if not self.right:
                self.right = node
                return True
            return self.right.insert(node)
        elif node.end <= self.start:
            if not self.left:
                self.left = node
                return True
            return self.left.insert(node)
        else:
            return False

class MyCalendar(object):

    def __init__(self):
        self.root = None

    def book(self, start, end):
        """
        :type start: int
        :type end: int
        :rtype: bool
        """
        if not self.root:
            self.root = Node(start, end)
            return True
        return self.root.insert(Node(start, end))
```

> 思路 3
******- 时间复杂度: O(lgN)******- 空间复杂度: O(N)******

刚才我们是挨个比对，所以比对过程是O(N)，但是由于我们已经保证了start按照升序排列，所以我们可以用二分算出合理的插入位置，然后看看是否有冲突即可

这次用最正宗的二分


- Return True if the insersion point is at the end of the array
- Return False if the insertion point overlaps with an existing calendar event
    - the insertion point ```right_idx``` is odd, which means current events[right_idx-1](it's a start) < start < events[right_idx](it's a end)
    - end > events[right_idx])(it's a start), that means the current end ovelap with the events[right_idx](which is a start)
- Otherwise return True

beats 100%

```python
class MyCalendar(object):

    def __init__(self):
        self.events = []

    def book(self, start, end):
        """
        :type start: int
        :type end: int
        :rtype: bool
        """
        right_idx = bisect.bisect_right(self.events, start)
        if right_idx < len(self.events) and (right_idx & 1 or end > self.events[right_idx]):
            return False
        
        self.events[right_idx:right_idx] = [start, end]
        return True
```

































