# 733. Flood Fill

**<font color=red>难度: Easy</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/flood-fill/description/

> 内容描述

```
An image is represented by a 2-D array of integers, each integer representing the pixel value of the image (from 0 to 65535).

Given a coordinate (sr, sc) representing the starting pixel (row and column) of the flood fill, and a pixel value newColor, "flood fill" the image.

To perform a "flood fill", consider the starting pixel, plus any pixels connected 4-directionally to the starting pixel of the same color as the starting pixel, plus any pixels connected 4-directionally to those pixels (also with the same color as the starting pixel), and so on. Replace the color of all of the aforementioned pixels with the newColor.

At the end, return the modified image.

Example 1:
Input: 
image = [[1,1,1],[1,1,0],[1,0,1]]
sr = 1, sc = 1, newColor = 2
Output: [[2,2,2],[2,2,0],[2,0,1]]
Explanation: 
From the center of the image (with position (sr, sc) = (1, 1)), all pixels connected 
by a path of the same color as the starting pixel are colored with the new color.
Note the bottom corner is not colored 2, because it is not 4-directionally connected
to the starting pixel.
Note:

The length of image and image[0] will be in the range [1, 50].
The given starting pixel will satisfy 0 <= sr < image.length and 0 <= sc < image[0].length.
The value of each color in image[i][j] and newColor will be an integer in [0, 65535].

```

## 解题方案

> 思路 1
******- 时间复杂度: O(N^2)******- 空间复杂度: O(N^2)******


dfs, 多加了一层判断，只有周围color一样才放进stack里面

beats 82.56%

```python
class Solution(object):
    def floodFill(self, image, sr, sc, newColor):
        """
        :type image: List[List[int]]
        :type sr: int
        :type sc: int
        :type newColor: int
        :rtype: List[List[int]]
        """
        row = len(image)
        col = len(image[0]) if row else 0
        directions = [[1,0], [-1,0], [0,1], [0,-1]]
        
        def dfs(image, sr, sc, color):
            stack, visited = [[sr, sc]], []
            while stack:
                vertex = stack.pop()
                if vertex not in visited:
                    visited.append(vertex)
                    x, y = vertex[0], vertex[1]
                    for m,n in [[x-1,y], [x+1,y], [x,y-1], [x,y+1]]:
                        if 0 <= m < row and 0 <= n < col:
                            if [m,n] not in visited:
                                if image[m][n] == color:
                                    stack.append([m,n])
            return visited

        for i in dfs(image, sr, sc, image[sr][sc]):
            image[i[0]][i[1]] = newColor
        return image
```
