# 735. Asteroid Collision

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/asteroid-collision/

> 内容描述

```
We are given an array asteroids of integers representing asteroids in a row.

For each asteroid, the absolute value represents its size, and the sign represents its direction (positive meaning right, negative meaning left). Each asteroid moves at the same speed.

Find out the state of the asteroids after all collisions. If two asteroids meet, the smaller one will explode. If both are the same size, both will explode. Two asteroids moving in the same direction will never meet.

Example 1:
Input: 
asteroids = [5, 10, -5]
Output: [5, 10]
Explanation: 
The 10 and -5 collide resulting in 10.  The 5 and 10 never collide.
Example 2:
Input: 
asteroids = [8, -8]
Output: []
Explanation: 
The 8 and -8 collide exploding each other.
Example 3:
Input: 
asteroids = [10, 2, -5]
Output: [10]
Explanation: 
The 2 and -5 collide resulting in -5.  The 10 and -5 collide resulting in 10.
Example 4:
Input: 
asteroids = [-2, -1, 1, 2]
Output: [-2, -1, 1, 2]
Explanation: 
The -2 and -1 are moving left, while the 1 and 2 are moving right.
Asteroids moving the same direction never meet, so no asteroids will meet each other.
Note:

The length of asteroids will be at most 10000.
Each asteroid will be a non-zero integer in the range [-1000, 1000]..
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******

直接模拟用stack, 一遍ac，beats 100%

我们发现最终结果肯定是左边全是负数，右边全是正数的形式

用两个栈right和left模拟，进行一次遍历，
- 碰到正数说明是往右边move的，直接放到right里面
- 碰到负数说明是往左边move的
  - 如果此时right里面有行星，说明当前行星和right里面最后一个行星会发生碰撞，我们要比较他们的size了
    - 如果一样大，我们直接删除right里面的最后一个行星，然后break继续遍历
    - 如果right里面的最后一个行星更大，说明当前行星会爆炸，直接break继续遍历
    - 如果right里面的最后一个行星更小，说明right里面的最后一个行星会爆炸，我们要继续判断当前行星和此时right里面新的最后一个行星的size
  - 如果right里面没有行星了，说明不会有行星与当前行星碰撞，我们把当前行星放到left里面

```python
class Solution:
    def asteroidCollision(self, asteroids):
        """
        :type asteroids: List[int]
        :rtype: List[int]
        """
        right, left = [], []
        for ast in asteroids:
            if ast > 0:
                right.append(ast)
            elif ast < 0:
                while right:
                    if right[-1] > abs(ast):
                        break
                    elif right[-1] == abs(ast):
                        del right[-1]
                        break
                    else:
                        del right[-1]
                else:
                    left.append(ast)
        return left + right
```


或者直接用一个stack也可以

```python
class Solution:
    def asteroidCollision(self, asteroids):
        """
        :type asteroids: List[int]
        :rtype: List[int]
        """
        res = []
        for ast in asteroids:
            if not res or ast > 0:
                res.append(ast)
            elif ast < 0:
                while res and res[-1] > 0:
                    if res[-1] == -ast: 
                        res.pop()
                        break
                    elif res[-1] < -ast:
                        res.pop()
                    elif res[-1] > -ast:
                        break
                else:
                    res.append(ast)
        return res
```

































