# 746. Min Cost Climbing Stairs

**<font color=red>难度: Easy</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/min-cost-climbing-stairs/

> 内容描述

```
On a staircase, the i-th step has some non-negative cost cost[i] assigned (0 indexed).

Once you pay the cost, you can either climb one or two steps. You need to find minimum cost to reach the top of the floor, and you can either start from the step with index 0, or the step with index 1.

Example 1:
Input: cost = [10, 15, 20]
Output: 15
Explanation: Cheapest is start on cost[1], pay that cost and go to the top.
Example 2:
Input: cost = [1, 100, 1, 1, 1, 100, 1, 1, 100, 1]
Output: 6
Explanation: Cheapest is start on cost[0], and only step on 1s, skipping cost[3].
Note:
cost will have a length in the range [2, 1000].
Every cost[i] will be an integer in the range [0, 999].
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******

典型dp，dp[i]代表走到index为i的台阶所需要的最小的cost

状态转移方程： ```dp[i] = min(dp[i-1] + cost[i], dp[i-1] + cost[i+1], dp[i-2] + cost[i])```

由于到最后cost[i+1]会index out of bound，所以在最开始的时候就让cost += [0]，这样一来避免这个错误，二来0不会影响最终结果

beats 27.15%

```python
class Solution(object):
    def minCostClimbingStairs(self, cost):
        """
        :type cost: List[int]
        :rtype: int
        """
        dp = cost[:2] + [0] * (len(cost) - 2) 
        cost += [0]
        for i in range(2, len(cost)-1):
            dp[i] = min(dp[i-1] + cost[i], dp[i-1] + cost[i+1], dp[i-2] + cost[i])
        return dp[-1]
```





























