# 752. Open the Lock

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/open-the-lock/

> 内容描述

```
You have a lock in front of you with 4 circular wheels. Each wheel has 10 slots: '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'. The wheels can rotate freely and wrap around: for example we can turn '9' to be '0', or '0' to be '9'. Each move consists of turning one wheel one slot.

The lock initially starts at '0000', a string representing the state of the 4 wheels.

You are given a list of deadends dead ends, meaning if the lock displays any of these codes, the wheels of the lock will stop turning and you will be unable to open it.

Given a target representing the value of the wheels that will unlock the lock, return the minimum total number of turns required to open the lock, or -1 if it is impossible.

Example 1:
Input: deadends = ["0201","0101","0102","1212","2002"], target = "0202"
Output: 6
Explanation:
A sequence of valid moves would be "0000" -> "1000" -> "1100" -> "1200" -> "1201" -> "1202" -> "0202".
Note that a sequence like "0000" -> "0001" -> "0002" -> "0102" -> "0202" would be invalid,
because the wheels of the lock become stuck after the display becomes the dead end "0102".
Example 2:
Input: deadends = ["8888"], target = "0009"
Output: 1
Explanation:
We can turn the last wheel in reverse to move from "0000" -> "0009".
Example 3:
Input: deadends = ["8887","8889","8878","8898","8788","8988","7888","9888"], target = "8888"
Output: -1
Explanation:
We can't reach the target without getting stuck.
Example 4:
Input: deadends = ["0000"], target = "8888"
Output: -1
Note:
The length of deadends will be in the range [1, 500].
target will not be in the list deadends.
Every string in deadends and the string target will be a string of 4 digits from the 10,000 possibilities '0000' to '9999'.
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N^2 * 10^N + D)******- 空间复杂度: O(10^N + D)******

典型BDS, beats 39.85%, 参考[solution](https://leetcode.com/problems/open-the-lock/solution/)

- 时间复杂度中的N是lock的位数，即4
- 时间复杂度中的D是deadends的长度
- 10指的是0,1,2,...,9的长度为10


```python
class Solution:
    def openLock(self, deadends, target):
        """
        :type deadends: List[str]
        :type target: str
        :rtype: int
        """
        def getNext(cur):
            for i in range(len(cur)):
                x = int(cur[i])
                for d in (-1, 1):
                    y = (x + d) % 10
                    yield cur[:i] + str(y) + cur[i+1:]

        dead = set(deadends)
        queue = collections.deque([('0000', 0)])
        visited = {'0000'}
        while queue:
            cur, depth = queue.popleft()
            if cur == target: 
                return depth
            if cur in dead: 
                continue
            for nxt in getNext(cur):
                if nxt not in visited:
                    visited.add(nxt)
                    queue.append((nxt, depth+1))
        return -1
```






























