# 785. Is Graph Bipartite?

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/is-graph-bipartite/description/

> 内容描述

```

Given an undirected graph, return true if and only if it is bipartite.

Recall that a graph is bipartite if we can split it's set of nodes into two independent subsets A and B such that every edge in the graph has one node in A and another node in B.

The graph is given in the following form: graph[i] is a list of indexes j for which the edge between nodes i and j exists.  Each node is an integer between 0 and graph.length - 1.  There are no self edges or parallel edges: graph[i] does not contain i, and it doesn't contain any element twice.

Example 1:
Input: [[1,3], [0,2], [1,3], [0,2]]
Output: true
Explanation: 
The graph looks like this:
0----1
|    |
|    |
3----2
We can divide the vertices into two groups: {0, 2} and {1, 3}.
Example 2:
Input: [[1,2,3], [0,2], [0,1,3], [0,2]]
Output: false
Explanation: 
The graph looks like this:
0----1
| \  |
|  \ |
3----2
We cannot find a way to divide the set of nodes into two independent subsets.
 

Note:

graph will have length in range [1, 100].
graph[i] will contain integers in range [0, graph.length - 1].
graph[i] will not contain i or duplicate values.
The graph is undirected: if any element j is in graph[i], then i will be in graph[j].
```

## 解题方案

> 思路 1
******- 时间复杂度: O(V+E)******- 空间复杂度: O(V)******

对于二分图中任意一点来说，它的neighbor都必定在另外一个集合，否则就不是二分图

BFS的思想

beats 100%

```python
class Solution:
    def isBipartite(self, graph):
        """
        :type graph: List[List[int]]
        :rtype: bool
        """
        visited = set()
        for i in range(len(graph)):
            if i in visited or not graph[i]:
                continue
            cur_level = set([i])
            while cur_level:
                nxt_level = set()
                for j in cur_level:
                    visited.add(j)
                    for n in graph[j]:
                        if n in cur_level:
                            return False
                        if n not in visited:
                            nxt_level.add(n)
                cur_level = nxt_level
        return True
```
