# 918. Maximum Sum Circular Subarray

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/maximum-sum-circular-subarray/description/

> 内容描述

```
Given a circular array C of integers represented by A, find the maximum possible sum of a non-empty subarray of C.

Here, a circular array means the end of the array connects to the beginning of the array.  (Formally, C[i] = A[i] when 0 <= i < A.length, and C[i+A.length] = C[i] when i >= 0.)

Also, a subarray may only include each element of the fixed buffer A at most once.  (Formally, for a subarray C[i], C[i+1], ..., C[j], there does not exist i <= k1, k2 <= j with k1 % A.length = k2 % A.length.)

 

Example 1:

Input: [1,-2,3,-2]
Output: 3
Explanation: Subarray [3] has maximum sum 3
Example 2:

Input: [5,-3,5]
Output: 10
Explanation: Subarray [5,5] has maximum sum 5 + 5 = 10
Example 3:

Input: [3,-1,2,-1]
Output: 4
Explanation: Subarray [2,-1,3] has maximum sum 2 + (-1) + 3 = 4
Example 4:

Input: [3,-2,2,-3]
Output: 3
Explanation: Subarray [3] and [3,-2,2] both have maximum sum 3
Example 5:

Input: [-2,-3,-1]
Output: -1
Explanation: Subarray [-1] has maximum sum -1
 

Note:

-30000 <= A[i] <= 30000
1 <= A.length <= 30000
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N^2)******- 空间复杂度: O(1)******






直接用53题的最优思想做，然后参考了[寒神的牛p思想](https://leetcode.com/problems/maximum-sum-circular-subarray/discuss/178422/C++JavaPython-One-Pass)

```
The max subarray circular sum equals to
max(the max subarray sum, the total sum - the min subarray sum)

One corner case: If all number are negative, return the maximum one, (which equals to the max subarray sum)
```

```python
class Solution(object):
    def maxSubarraySumCircular(self, A):
        """
        :type A: List[int]
        :rtype: int
        """
        nums = A
        flag = all(num < 0 for num in nums)
        max_sum, max_end, min_sum, min_end = nums[0], nums[0], nums[0], nums[0]
        for i in range(1, len(nums)):
            max_end = max(nums[i], max_end+nums[i])
            max_sum = max(max_sum, max_end)
            min_end = min(nums[i], min_end+nums[i])
            min_sum = min(min_sum, min_end)
        return max(max_sum, sum(nums) - min_sum) if not flag else max(nums)
```























