# 950. Reveal Cards In Increasing Order

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/reveal-cards-in-increasing-order/

> 内容描述

```
In a deck of cards, every card has a unique integer.  You can order the deck in any order you want.

Initially, all the cards start face down (unrevealed) in one deck.

Now, you do the following steps repeatedly, until all cards are revealed:

Take the top card of the deck, reveal it, and take it out of the deck.
If there are still cards in the deck, put the next top card of the deck at the bottom of the deck.
If there are still unrevealed cards, go back to step 1.  Otherwise, stop.
Return an ordering of the deck that would reveal the cards in increasing order.

The first entry in the answer is considered to be the top of the deck.

 

Example 1:

Input: [17,13,11,2,3,5,7]
Output: [2,13,3,11,5,17,7]
Explanation: 
We get the deck in the order [17,13,11,2,3,5,7] (this order doesn't matter), and reorder it.
After reordering, the deck starts as [2,13,3,11,5,17,7], where 2 is the top of the deck.
We reveal 2, and move 13 to the bottom.  The deck is now [3,11,5,17,7,13].
We reveal 3, and move 11 to the bottom.  The deck is now [5,17,7,13,11].
We reveal 5, and move 17 to the bottom.  The deck is now [7,13,11,17].
We reveal 7, and move 13 to the bottom.  The deck is now [11,17,13].
We reveal 11, and move 17 to the bottom.  The deck is now [13,17].
We reveal 13, and move 17 to the bottom.  The deck is now [17].
We reveal 17.
Since all the cards revealed are in increasing order, the answer is correct.
 

Note:

1 <= A.length <= 1000
1 <= A[i] <= 10^6
A[i] != A[j] for all i != j
```

## 解题方案

> 思路 1
******- 时间复杂度: O(NlgN)******- 空间复杂度: O(1)******

递归, 参考[2017111303](https://leetcode.com/problems/reveal-cards-in-increasing-order/discuss/200518/nlogn-python-solution-(recursion))

```python
class Solution:
    def deckRevealedIncreasing(self, deck):
        """
        :type deck: List[int]
        :rtype: List[int]
        """
        deck.sort()
        def helper(deck):
            n = len(deck)
            if n == 1: return deck
            res = [0] * n
            if n % 2 == 1:
                index = (n+1) // 2
                res[0::2] = deck[:index]
                res[1::2] = helper(deck[index-1:])[1:]
            else:
                index = n // 2
                res[0::2] = deck[:index]
                res[1::2] = helper(deck[index:])
            return res
        return helper(deck)
```


> 思路 2
******- 时间复杂度: O(NlgN)******- 空间复杂度: O(1)******

逆向思维，倒着回去就行

```python
class Solution:
    def deckRevealedIncreasing(self, deck):
        """
        :type deck: List[int]
        :rtype: List[int]
        """
        deck.sort()
        res = collections.deque([deck[-1]])
        for i in deck[:-1][::-1]:
            tmp = res.pop()
            res.appendleft(tmp)
            res.appendleft(i)
        return [i for i in res]
```
