# 971. Flip Binary Tree To Match Preorder Traversal

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/flip-binary-tree-to-match-preorder-traversal/

> 内容描述

```
Given a binary tree with N nodes, each node has a different value from {1, ..., N}.

A node in this binary tree can be flipped by swapping the left child and the right child of that node.

Consider the sequence of N values reported by a preorder traversal starting from the root.  Call such a sequence of N values the voyage of the tree.

(Recall that a preorder traversal of a node means we report the current node's value, then preorder-traverse the left child, then preorder-traverse the right child.)

Our goal is to flip the least number of nodes in the tree so that the voyage of the tree matches the voyage we are given.

If we can do so, then return a list of the values of all nodes flipped.  You may return the answer in any order.

If we cannot do so, then return the list [-1].

 

Example 1:



Input: root = [1,2], voyage = [2,1]
Output: [-1]
Example 2:



Input: root = [1,2,3], voyage = [1,3,2]
Output: [1]
Example 3:



Input: root = [1,2,3], voyage = [1,2,3]
Output: []
 

Note:

1 <= N <= 100
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N^2)******- 空间复杂度: O(1)******



各种corner case，递归

```python
class Solution:
    
    def count(self, root):
        if not root:
            return 0
        return 1 + self.count(root.left) + self.count(root.right)
    
    def flipMatchVoyage(self, root, voyage):
        """
        :type root: TreeNode
        :type voyage: List[int]
        :rtype: List[int]
        """
        if not voyage and not root:
            return []
        elif not voyage or not root:
            return [-1]
        
        if voyage[0] != root.val:
            return [-1]

        if not root.left:
            return self.flipMatchVoyage(root.right, voyage[1:])
        elif not root.right:
            return self.flipMatchVoyage(root.left, voyage[1:])
        else:
            if voyage[1] == root.left.val:
                cnt = self.count(root.left)
                resl = self.flipMatchVoyage(root.left, voyage[1:cnt+1])
                resr = self.flipMatchVoyage(root.right, voyage[cnt+1:])
                if resl == [-1] or resr == [-1]:
                    return [-1]
                return resl + resr
            else:
                cnt = self.count(root.right)
                resl = self.flipMatchVoyage(root.right, voyage[1:cnt+1])
                resr = self.flipMatchVoyage(root.left, voyage[cnt+1:])
                if resl == [-1] or resr == [-1]:
                    return [-1]
                return [root.val] + resl + resr # 需要flip当前root
```






























