# 979. Distribute Coins in Binary Tree

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/distribute-coins-in-binary-tree/

> 内容描述

```
Given the root of a binary tree with N nodes, each node in the tree has node.val coins, and there are N coins total.

In one move, we may choose two adjacent nodes and move one coin from one node to another.  (The move may be from parent to child, or from child to parent.)

Return the number of moves required to make every node have exactly one coin.

 

Example 1:



Input: [3,0,0]
Output: 2
Explanation: From the root of the tree, we move one coin to its left child, and one coin to its right child.
Example 2:



Input: [0,3,0]
Output: 3
Explanation: From the left child of the root, we move two coins to the root [taking two moves].  Then, we move one coin from the root of the tree to the right child.
Example 3:



Input: [1,0,2]
Output: 2
Example 4:



Input: [1,0,0,null,3]
Output: 4
 

Note:

1<= N <= 100
0 <= node.val <= N
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N)******- 空间复杂度: O(1)******



递归，对于root来说，如果left的coins比较多，那么需要移动多余的到root后，再由root移给right即可


```python
class Solution:
    res = 0
    def distributeCoins(self, root):
        """
        :type root: TreeNode
        :rtype: int
        """
        def countSum(node):
            if not node:
                return 0
            return countSum(node.left) + node.val + countSum(node.right)
        
        def count(node):
            if not node:
                return 0
            return count(node.left) + 1 + count(node.right)
        
        if not root:
            return 0
        self.res += abs(count(root.left) - countSum(root.left)) + abs(count(root.right) - countSum(root.right))
        self.distributeCoins(root.left)
        self.distributeCoins(root.right)
        return self.res
```



































