# 981. Time Based Key-Value Store

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/time-based-key-value-store/

> 内容描述

```
Create a timebased key-value store class TimeMap, that supports two operations.

1. set(string key, string value, int timestamp)

Stores the key and value, along with the given timestamp.
2. get(string key, int timestamp)

Returns a value such that set(key, value, timestamp_prev) was called previously, with timestamp_prev <= timestamp.
If there are multiple such values, it returns the one with the largest timestamp_prev.
If there are no values, it returns the empty string ("").
 

Example 1:

Input: inputs = ["TimeMap","set","get","get","set","get","get"], inputs = [[],["foo","bar",1],["foo",1],["foo",3],["foo","bar2",4],["foo",4],["foo",5]]
Output: [null,null,"bar","bar",null,"bar2","bar2"]
Explanation:   
TimeMap kv;   
kv.set("foo", "bar", 1); // store the key "foo" and value "bar" along with timestamp = 1   
kv.get("foo", 1);  // output "bar"   
kv.get("foo", 3); // output "bar" since there is no value corresponding to foo at timestamp 3 and timestamp 2, then the only value is at timestamp 1 ie "bar"   
kv.set("foo", "bar2", 4);   
kv.get("foo", 4); // output "bar2"   
kv.get("foo", 5); //output "bar2"   

Example 2:

Input: inputs = ["TimeMap","set","set","get","get","get","get","get"], inputs = [[],["love","high",10],["love","low",20],["love",5],["love",10],["love",15],["love",20],["love",25]]
Output: [null,null,null,"","high","high","low","low"]
 

Note:

All key/value strings are lowercase.
All key/value strings have length in the range [1, 100]
The timestamps for all TimeMap.set operations are strictly increasing.
1 <= timestamp <= 10^7
TimeMap.set and TimeMap.get functions will be called a total of 120000 times (combined) per test case.
```

## 解题方案

> 思路 1
******- 时间复杂度: set O(lgN) + get O(KlgK)******- 空间复杂度: O(N)******



heapq就可以了


```python
from heapq import heapify, heappush, heappop

class TimeMap:
    def __init__(self):
        """
        Initialize your data structure here.
        """
        self.lookup = collections.defaultdict(list)

    def set(self, key: 'str', value: 'str', timestamp: 'int') -> 'None':
        if key not in self.lookup:
            heapify(self.lookup[key])
        heappush(self.lookup[key], (-timestamp, value))    

    def get(self, key: 'str', timestamp: 'int') -> 'str':
        if key not in self.lookup:
            return ''
        else:
            tmp = heappop(self.lookup[key])
            lst = [tmp]
            while self.lookup[key] and -tmp[0] > timestamp:
                tmp = heappop(self.lookup[key])
                lst.append(tmp)
            for i in lst:
                heappush(self.lookup[key], i)
            if -tmp[0] <= timestamp:
                return tmp[1]
            else:
                return ''
```








































