# 983. Minimum Cost For Tickets

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/minimum-cost-for-tickets/

> 内容描述

```
In a country popular for train travel, you have planned some train travelling one year in advance.  The days of the year that you will travel is given as an array days.  Each day is an integer from 1 to 365.

Train tickets are sold in 3 different ways:

a 1-day pass is sold for costs[0] dollars;
a 7-day pass is sold for costs[1] dollars;
a 30-day pass is sold for costs[2] dollars.
The passes allow that many days of consecutive travel.  For example, if we get a 7-day pass on day 2, then we can travel for 7 days: day 2, 3, 4, 5, 6, 7, and 8.

Return the minimum number of dollars you need to travel every day in the given list of days.

 

Example 1:

Input: days = [1,4,6,7,8,20], costs = [2,7,15]
Output: 11
Explanation: 
For example, here is one way to buy passes that lets you travel your travel plan:
On day 1, you bought a 1-day pass for costs[0] = $2, which covered day 1.
On day 3, you bought a 7-day pass for costs[1] = $7, which covered days 3, 4, ..., 9.
On day 20, you bought a 1-day pass for costs[0] = $2, which covered day 20.
In total you spent $11 and covered all the days of your travel.
Example 2:

Input: days = [1,2,3,4,5,6,7,8,9,10,30,31], costs = [2,7,15]
Output: 17
Explanation: 
For example, here is one way to buy passes that lets you travel your travel plan:
On day 1, you bought a 30-day pass for costs[2] = $15 which covered days 1, 2, ..., 30.
On day 31, you bought a 1-day pass for costs[0] = $2 which covered day 31.
In total you spent $17 and covered all the days of your travel.
 

Note:

1 <= days.length <= 365
1 <= days[i] <= 365
days is in strictly increasing order.
costs.length == 3
1 <= costs[i] <= 1000
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******

无语了， 比赛的时候交就超时，比赛后就过了？？？？？

从最后一天开始，对于这一天，我们有三种方式：
- 它被1-day pass所cover
- 它被7-day pass所cover
- 它被30-day pass所cover

算出哪一种最省钱就可以了

```python
from functools import lru_cache

class Solution:
    def mincostTickets(self, days: 'List[int]', costs: 'List[int]') -> 'int':
        @lru_cache(None)
        def helper(days):
            days = list(days)
            if not days:
                return 0

            res = sys.maxsize
            cur = days[-1]
            res = min(res, costs[0] + helper(tuple(days[:-1])))
            while days and days[-1] >= cur - 6:
                days.pop()
            res = min(res, costs[1] + helper(tuple(days)))
            while days and days[-1] >= cur - 29:
                days.pop()
            res = min(res, costs[2] + helper(tuple(days)))
            return res
        return helper(tuple(days))
```



> 思路 2
******- 时间复杂度: O(W)******- 空间复杂度: O(W)******


上面写的太难看了，所以换种思路，我们用dp[i]来代表从第i天到days[-1]天需要多少钱

时间复杂度中的W就是365

抄[solution](https://leetcode.com/problems/minimum-cost-for-tickets/submissions/)

```python
from functools import lru_cache

class Solution:
    def mincostTickets(self, days: 'List[int]', costs: 'List[int]') -> 'int':
        dayset = set(days)
        durations = [1, 7, 30]

        @lru_cache(None)
        def dp(i):
            if i > 365:
                return 0
            elif i in dayset:
                return min(dp(i + d) + c
                           for c, d in zip(costs, durations))
            else:
                return dp(i + 1)

        return dp(1)
```




> 思路 3
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******



抄[solution](https://leetcode.com/problems/minimum-cost-for-tickets/submissions/)

这次我们考虑用dp[i]来代表从第days[i]天到days[-1]天需要多少钱


```python
from functools import lru_cache

class Solution:
    def mincostTickets(self, days: 'List[int]', costs: 'List[int]') -> 'int':
        N = len(days)
        durations = [1, 7, 30]

        @lru_cache(None)
        def dp(i): # How much money to do days[i]+
            if i >= N: 
                return 0
            res = float('inf')
            cur_day = days[i]
            for c, d in zip(costs, durations):
                while i < N and days[i] < cur_day + d:
                    i += 1
                res = min(res, dp(i) + c)
            return res

        return dp(0)
```























