# 986. Interval List Intersections

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/interval-list-intersections/

> 内容描述

```
Given two lists of closed intervals, each list of intervals is pairwise disjoint and in sorted order.

Return the intersection of these two interval lists.

(Formally, a closed interval [a, b] (with a <= b) denotes the set of real numbers x with a <= x <= b.  The intersection of two closed intervals is a set of real numbers that is either empty, or can be represented as a closed interval.  For example, the intersection of [1, 3] and [2, 4] is [2, 3].)

 

Example 1:



Input: A = [[0,2],[5,10],[13,23],[24,25]], B = [[1,5],[8,12],[15,24],[25,26]]
Output: [[1,2],[5,5],[8,10],[15,23],[24,24],[25,25]]
Reminder: The inputs and the desired output are lists of Interval objects, and not arrays or lists.
 

Note:

0 <= A.length < 1000
0 <= B.length < 1000
0 <= A[i].start, A[i].end, B[i].start, B[i].end < 10^9
```

## 解题方案

> 思路 1
******- 时间复杂度: O(len(A) + len(B))******- 空间复杂度: O(1)******




双指针

```python
class Solution:
    def intervalIntersection(self, A: 'List[Interval]', B: 'List[Interval]') -> 'List[Interval]':
        res = []
        i = j = 0
        while i < len(A) and j < len(B):
            al, ar = A[i].start, A[i].end
            bl, br = B[j].start, B[j].end
            if ar < br:
                i += 1
            else:
                j += 1
            if ar >= bl and br >= al:
                res.append(sorted([al, ar, bl, br])[1:-1])

        idx = 0
        while idx < len(res) - 1:
            if res[idx][1] == res[idx + 1][0]:
                res[idx:idx + 2] = [[res[idx][0], res[idx + 1][1]]]
            idx += 1
        return res
```





























