# 987. Vertical Order Traversal of a Binary Tree

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/vertical-order-traversal-of-a-binary-tree/

> 内容描述

```
Given a binary tree, return the vertical order traversal of its nodes values.

For each node at position (X, Y), its left and right children respectively will be at positions (X-1, Y-1) and (X+1, Y-1).

Running a vertical line from X = -infinity to X = +infinity, whenever the vertical line touches some nodes, we report the values of the nodes in order from top to bottom (decreasing Y coordinates).

If two nodes have the same position, then the value of the node that is reported first is the value that is smaller.

Return an list of non-empty reports in order of X coordinate.  Every report will have a list of values of nodes.

 

Example 1:



Input: [3,9,20,null,null,15,7]
Output: [[9],[3,15],[20],[7]]
Explanation: 
Without loss of generality, we can assume the root node is at position (0, 0):
Then, the node with value 9 occurs at position (-1, -1);
The nodes with values 3 and 15 occur at positions (0, 0) and (0, -2);
The node with value 20 occurs at position (1, -1);
The node with value 7 occurs at position (2, -2).
Example 2:



Input: [1,2,3,4,5,6,7]
Output: [[4],[2],[1,5,6],[3],[7]]
Explanation: 
The node with value 5 and the node with value 6 have the same position according to the given scheme.
However, in the report "[1,5,6]", the node value of 5 comes first since 5 is smaller than 6.
 

Note:

The tree will have between 1 and 1000 nodes.
Each node's value will be between 0 and 1000.
```

## 解题方案

> 思路 1
******- 时间复杂度: O(NlgN)******- 空间复杂度: O(N)******

先遍历树，将每个点的坐标和其val都存下来, 形式为(x,y,val)，最后按照x,-y,val的方式排序所有点，然后根据x分类返回
```python
class Solution:
    def verticalTraversal(self, root: 'TreeNode') -> 'List[List[int]]':
        self.points = []
        
        def helper(node, x, y):
            if not node:
                return []
            self.points.append([x, y, node.val])
            helper(node.left, x-1, y-1)
            helper(node.right, x+1, y-1)
            
        helper(root, 0, 0)
        self.points.sort(key = lambda x: (x[0], -x[1], x[2])) # 这句是精髓
        lookup = collections.defaultdict(list)
        for i, lst in enumerate(self.points):
            lookup[lst[0]].append(lst[-1])
            
        res = []
        for i in sorted(list(lookup.keys())):
            res.append(lookup[i])
        return res
```


































